/**
 * 
 */


import java.util.Objects;

/**
 * @author kahlem
 *
 */

public class Article implements Comparable<Article> {
	private int reference;
	private String libelle;
	private String fournisseur;

	public int getReference() {
		return reference;
	}

	private double prixAchat;
	private double prixArticle;
	private double prixVente;
	
	public Article (int ref,String l, String f, double prixAchat, double prixArticle){
		reference=ref;
		libelle =l;
		fournisseur = f;
		this.prixAchat = prixAchat;
		this.prixArticle = prixArticle;
		prixVente = prixArticle;
	}
	public void promotion (int pourcentage){//0,5
		prixVente = prixArticle - prixArticle * pourcentage/100;
	}
	
	public void remonterPrix (){//0,25
		prixVente = prixArticle ;
	}

	public String toString(){
		return "L'article numéro : "+reference+ " nommé " + libelle + " a pour fournisseur "+ fournisseur+
				"\n Prix achat :"+ prixAchat +"\n Prix de l'article :"+ prixArticle + "\n PrixVente :"+ prixVente;
	}
	/**
	 * @return the prixAchat
	 */
	public double getPrixAchat() {
		return prixAchat;
	}
	/**
	 * @param prixAchat the prixAchat to set
	 */
	public void setPrixAchat(double prixAchat) {
		this.prixAchat = prixAchat;
	}
	/**
	 * @return the prixVente
	 */
	public double getPrixVente() {
		return prixVente;
	}
	/**
	 * @param prixVente the prixVente to set
	 */
	public void setPrixVente(double prixVente) {
		this.prixVente = prixVente;
	}

	/**
	 * @return the libelle
	 */
	public String getLibelle() {
		return libelle;
	}

	/**
	 * @param libelle the libelle to set
	 */
	public void setLibelle(String libelle) {
		this.libelle = libelle;
	}

	/**
	 * @return the fournisseur
	 */
	public String getFournisseur() {
		return fournisseur;
	}

	/**
	 * @param fournisseur the fournisseur to set
	 */
	public void setFournisseur(String fournisseur) {
		this.fournisseur = fournisseur;
	}
	/**
	 * @return the prixArticle
	 */
	public double getPrixArticle() {
		return prixArticle;
	}
	/**
	 * @param prixArticle the prixArticle to set
	 */
	public void setPrixArticle(double prixArticle) {
		this.prixArticle = prixArticle;
	}

	@Override
	public boolean equals(Object o) {
		if (this == o) return true;
		if (o == null || getClass() != o.getClass()) return false;
		Article article = (Article) o;
		return getReference() == article.getReference();
	}

	@Override
	public int hashCode() {
		return Objects.hash(getReference());
	}

	@Override
	public int compareTo(Article o) {
		return (int) (this.reference-o.reference);
	}
}
